# FastBiot_GPU3D

version 1.0

## Software

**FastBiot** is a software suite to model wave propagation in anisotropic poroelastic media using graphical processing units (GPUs). FastBiot is written in CUDA C, visualisation and other helper functions are written in Matlab. The routine is developed for a single GPU.

**Dispersion_relations_Biot** is a software suite (routines) to calculate the dispersion relations of the Biot's poroelastic equations.

07 Feb 2021 Copyright (C) 2021 Yury Alkhimenkov, Ludovic Raess, Lyudmila Khakimova, Beatriz Quintal, Yury Podladchikov

## Usage

### FastBiot
- Input:  Parameters are saved as input files `pa1.dat`, `pa2.dat`, `pa2.dat` that are generated by the Matlab script `vizme_FastBiot_GPU3D.m`.

- Output: The FastBiot code calculates wave fields `Vx`, `Vy`, `Vz` and saves them to disk in binary format.

To execute the GPU codes you need an Nvidia GPU with 3.0 GB of GPU DRAM, and Cuda/9.0 or above.

To run the code and visualise the results you can:

1. Execute the Matlab script `vizme_FastBiot_GPU3D.m`, or

2. Manually launch the code from the shell:
```sh
# to compile
nvcc -arch=sm_52 -O3 -DNBX=4 -DNBY=4 -DNBZ=4 -DOVERX=0 -DOVERY=0 -DOVERZ=0 -Dnt=300 -DNPARS1=10 -DNPARS2=13 -DNPARS3=15  FastBiot_GPU3D_v1.cu

# to run:
./a.out
```

## Reference
Please cite us if you use our routine (will be updated upon final publication):
```tex
@article{Alkhimenkov2021,
    title={Resolving wave propagation in anisotropic poroelastic media using graphical processing units (GPUs)},
    author={Alkhimenkov, Yury and R{\"a}ss, Ludovic and Khakimova, Liudmila and Quintal, Beatriz and Podladchikov, Yuri Y.},
    year={2021},
}
```

### LICENSE
FastBiot_GPU3D is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FastBiot_GPU3D is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FastBiot_GPU3D. If not, see <http://www.gnu.org/licenses/>.
